/*==============================================================*/
/* @table: om_p_admin (om_p_001)                                */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-7-16 20:07                                    */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_admin
(
vc_userid         varchar(50)   not null,
vc_packageId      varchar(50)   not null,
vc_description    varchar(255),
dat_create        datetime,
primary key(vc_userid,vc_packageId)
);

/*==============================================================*/
/* @table: om_p_user (om_p_002)                                 */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-5 23:42                                     */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_user
(
vc_uuid           varchar(50)   not null,
vc_rankid         varchar(50)   ,        
vc_name           varchar(50)   not null,
vc_fullname       varchar(100)  ,
vc_password       varchar(50)   not null,
vc_description    varchar(255),
dat_create        datetime,
primary key(vc_uuid)
);

/*==============================================================*/
/* @table: om_p_rank (om_p_003)                                 */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-7-16 21:22                                    */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_rank
(
vc_uuid           varchar(50)   not null,
vc_name           varchar(50)   not null,
vc_description    varchar(255)  ,
dat_create        datetime,
primary key(vc_uuid),
unique(vc_name)
);

/*==============================================================*/
/* @table: om_p_department (om_p_004)                           */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-5 23:42                                     */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_department
(
vc_uuid           varchar(50)   not null,
vc_categoryid     varchar(50)   not null,
vc_presidentid    varchar(50)   ,
vc_name           varchar(50)   not null,
vc_parent         varchar(50)   ,
vc_description    varchar(255)  ,
dat_create        datetime,
primary key(vc_uuid)
);

/*==============================================================*/
/* @table: om_p_category (om_p_005)                             */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-5 23:42                                     */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_category
(
vc_uuid           varchar(50)   not null,
vc_name           varchar(50)   not null,
vc_description    varchar(255)  ,
dat_create        datetime,
primary key(vc_uuid),
unique(vc_name)
);

/*==============================================================*/
/* @table: om_p_group (om_p_006)                                */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-5 23:47                                     */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_group
(
vc_uuid           varchar(50)   not null,
vc_name           varchar(50)   not null,
vc_departmentid   varchar(50)   ,
vc_presidentid    varchar(50)   ,
vc_parent         varchar(50)   ,
vc_description    varchar(255)  ,
dat_create        datetime,
primary key(vc_uuid)
);

/*==============================================================*/
/* @table: om_p_role (om_p_007)                                 */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-5 23:47                                     */
/*                                                              */
/*                                                              */
/*==============================================================*/
create table om_p_role
(
vc_uuid           varchar(50)   not null,
vc_name           varchar(50)   not null,
vc_departmentid   varchar(50)   ,
vc_description    varchar(255)  ,
primary key(vc_uuid),
unique(vc_name)
);

/*==============================================================*/
/* @table: om_p_user_department (om_p_008)                      */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-6 0:34                                      */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_user_department
(
vc_departmenetid   varchar(50)   not null,
vc_userid          varchar(50)   not null,
primary key(vc_userid,vc_departmenetid)
);

/*==============================================================*/
/* @table: om_p_user_group (om_p_009)                           */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-6 0:34                                      */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_user_group
(
vc_userid   varchar(50)   not null,
vc_groupid  varchar(50)   not null,
primary key(vc_userid,vc_groupid)
);


/*==============================================================*/
/* @table: om_p_user_role (om_p_010)                            */
/*                                                              */
/* @desc:                                                       */
/*                                                              */
/* @created: 2004-4-6 0:34                                      */
/*                                                              */
/* @comment:                                                    */
/*                                                              */
/*==============================================================*/
create table om_p_user_role
(
vc_roleid   varchar(50)   not null,
vc_userid   varchar(50)   not null,
primary key(vc_roleid,vc_userid)
);
