/*
 * Created on 2004-9-5
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package workflow.client;

/**
 * @author reic
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public interface MatrixClient
{
	/**
		 * Constant that holds the name of the environment property
		 * for specifying the initial context factory to use. The value
		 * of the property should be the fully qualified class name
		 * of the factory class that will create an initial context.
		 * This property may be specified in the environment parameter
		 * passed to the initial context constructor, an applet parameter,
		 * a system property, or an application resource file.
		 * If it is not specified in any of these sources,
		 * <tt>NoWorkflowClientException</tt> is thrown when an initial
		 * context is required to complete an operation.
		 *
		 * <p> The value of this constant is "workflow.client.factory.initial".
		 *
		 * @see #addToEnvironment(String, Object)
		 * @see #removeFromEnvironment(String)
		 * @see #APPLET
		 */
		String INITIAL_CLIENT_FACTORY = "workflow.client.factory.initial";
	
		/**
		 * Constant that holds the name of the environment property
		 * for specifying configuration information for the service provider
		 * to use. The value of the property should contain a URL string
		 * (e.g. "jwfns://somehost:2126").
		 * This property may be specified in the environment,
		 * an applet parameter, a system property, or a resource file.
		 * If it is not specified in any of these sources,
		 * the default configuration is determined by the service provider.
		 *
		 * <p> The value of this constant is "workflow.client.provider.url".
		 *
		 * @see #addToEnvironment(String, Object)
		 * @see #removeFromEnvironment(String)
		 * @see #APPLET
		 */
		String PROVIDER_URL = "workflow.client.provider.url";

		/**
		 * Constant that holds the name of the environment property for
		 * specifying the identity of the principal for authenticating
		 * the caller to the service. The format of the principal
		 * depends on the authentication scheme.
		 * If this property is unspecified,
		 * the behaviour is determined by the service provider.
		 *
		 * <p> The value of this constant is "workflow.client.security.principal".
		 *
		 * @see #addToEnvironment(String, Object)
		 * @see #removeFromEnvironment(String)
		 */
		String SECURITY_PRINCIPAL = "workflow.client.security.principal";

		/**
		 * Constant that holds the name of the environment property for
		 * specifying the credentials of the principal for authenticating
		 * the caller to the service. The value of the property depends
		 * on the authentication scheme. For example, it could be a hashed
		 * password, clear-text password, key, certificate, and so on.
		 * If this property is unspecified,
		 * the behaviour is determined by the service provider.
		 *
		 * <p> The value of this constant is "workflow.client.security.credentials".
		 *
		 * @see #addToEnvironment(String, Object)
		 * @see #removeFromEnvironment(String)
		 */

		String SECURITY_CREDENTIALS = "workflow.client.security.credentials";	
	
		String LOCAL_BINDING_PORT    = "workflow.client.localport";
	
		String LOCAL_BINDING_ADDRESS = "workflow.client.localaddress";
}
